/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2018,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		ICM20602
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ3184284598)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2019-04-30
 * @note		
					߶壺
					------------------------------------ 
					ICM20602ģ(SPIͨ)   Ƭ                        
					SPC              		鿴SEEKFREE_ICM20602.hļеICM20602_SPC_PIN궨
					SDI              		鿴SEEKFREE_ICM20602.hļеICM20602_SDI_PIN궨
					SDO             		鿴SEEKFREE_ICM20602.hļеICM20602_SDO_PIN궨
					CS             			鿴SEEKFREE_ICM20602.hļеICM20602_CS_PIN궨
					------------------------------------ 
					ICM20602ģ(IICͨ)   Ƭ                        
					SCL              		鿴SEEKFREE_ICM20602.hļеICM20602_SCL_PIN궨
					SDA              		鿴SEEKFREE_ICM20602.hļеICM20602_SDA_PIN궨
					------------------------------------ 
 ********************************************************************************************************************/


#include "SEEKFREE_ICM20602.h"

#include "zf_delay.h"
#include "zf_spi.h"


#pragma warning disable = 177
#pragma warning disable = 183

int16 icm20602_gyro_x,icm20602_gyro_y,icm20602_gyro_z;
int16 icm20602_acc_x,icm20602_acc_y,icm20602_acc_z;


#if ICM20602_USE_SOFT_IIC


#define GET_ICM20602_SDA   		 	ICM20602_SDA_PIN
#define ICM20602_SDA_LOW()         	ICM20602_SDA_PIN = 0		//IO͵ƽ
#define ICM20602_SDA_HIGH()         ICM20602_SDA_PIN = 1		//IOߵƽ

#define ICM20602_SCL_LOW()          ICM20602_SCL_PIN = 0		//IO͵ƽ
#define ICM20602_SCL_HIGH()         ICM20602_SCL_PIN = 1		//IOߵƽ

#define ack 1      //Ӧ
#define no_ack 0   //Ӧ	

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICʱ
//  @return     void						
//  @since      v1.0
//  Sample usage:				IICͨѶʧܿԳjֵ
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simiic_delay(void)
{
    uint16 j=ICM20602_SOFT_IIC_DELAY;   
	while(j--);
}

//ڲʹãû
static void icm20602_simiic_start(void)
{
	ICM20602_SDA_HIGH();
	ICM20602_SCL_HIGH();
	icm20602_simiic_delay();
	ICM20602_SDA_LOW();
	icm20602_simiic_delay();
	ICM20602_SCL_LOW();
}

//ڲʹãû
static void icm20602_simiic_stop(void)
{
	ICM20602_SDA_LOW();
	ICM20602_SCL_LOW();
	icm20602_simiic_delay();
	ICM20602_SCL_HIGH();
	icm20602_simiic_delay();
	ICM20602_SDA_HIGH();
	icm20602_simiic_delay();
}

//Ӧ(ack:SDA=0no_ack:SDA=0)
//ڲʹãû
static void icm20602_simiic_sendack(unsigned char ack_dat)
{
    ICM20602_SCL_LOW();
	icm20602_simiic_delay();
	if(ack_dat) ICM20602_SDA_LOW();
    else    	ICM20602_SDA_HIGH();

    ICM20602_SCL_HIGH();
    icm20602_simiic_delay();
    ICM20602_SCL_LOW();
    icm20602_simiic_delay();
}


static int icm20602_sccb_waitack(void)
{
    ICM20602_SCL_LOW();

	icm20602_simiic_delay();
	
	ICM20602_SCL_HIGH();
    icm20602_simiic_delay();
	
    if(GET_ICM20602_SDA)           //ӦΪߵƽ쳣ͨʧ
    {

        ICM20602_SCL_LOW();
        return 0;
    }

    ICM20602_SCL_LOW();
	icm20602_simiic_delay();
    return 1;
}

//ֽڷͳ
//c(Ҳǵַ)մӦ
//ǴӦλ
//ڲʹãû
static void icm20602_send_ch(uint8 c)
{
	uint8 i = 8;
    while(i--)
    {
        if(c & 0x80)	ICM20602_SDA_HIGH();//SDA 
        else			ICM20602_SDA_LOW();
        c <<= 1;
        icm20602_simiic_delay();
        ICM20602_SCL_HIGH();                //SCL ߣɼź
        icm20602_simiic_delay();
        ICM20602_SCL_LOW();                //SCL ʱ
    }
	icm20602_sccb_waitack();
}


//ֽڽճ
//ݣ˳Ӧ|Ӧ|ʹ
//ڲʹãû
static uint8 icm20602_read_ch(uint8 ack_x)
{
    uint8 i;
    uint8 c;
    c=0;
    ICM20602_SCL_LOW();
    icm20602_simiic_delay();
    ICM20602_SDA_HIGH();             

    for(i=0;i<8;i++)
    {
        icm20602_simiic_delay();
        ICM20602_SCL_LOW();         //ʱΪͣ׼λ
        icm20602_simiic_delay();
        ICM20602_SCL_HIGH();         //ʱΪߣʹЧ
        icm20602_simiic_delay();
        c<<=1;
        if(GET_ICM20602_SDA) 
        {
            c+=1;   //λյݴc
        }
    }

	ICM20602_SCL_LOW();
	icm20602_simiic_delay();
	icm20602_simiic_sendack(ack_x);
	
    return c;
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICдݵ豸Ĵ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat				д
//  @return     void						
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simiic_write_reg(uint8 dev_add, uint8 reg, uint8 dat)
{
	icm20602_simiic_start();
    icm20602_send_ch( (dev_add<<1) | 0x00);   //ַдλ
	icm20602_send_ch( reg );   				 //ʹӻĴַ
	icm20602_send_ch( dat );   				 //Ҫд
	icm20602_simiic_stop();
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIIC豸Ĵȡ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static uint8 icm20602_simiic_read_reg(uint8 dev_add, uint8 reg)
{
	uint8 dat;
	icm20602_simiic_start();
    icm20602_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	icm20602_send_ch( reg );   				//ʹӻĴַ

	
	icm20602_simiic_start();
	icm20602_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
	dat = icm20602_read_ch(no_ack);   				//ȡ
	icm20602_simiic_stop();
	
	return dat;
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICȡֽ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat_add			ݱĵַָ
//  @param      num				ȡֽ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simiic_read_regs(uint8 dev_add, uint8 reg, uint8 *dat_add, uint32 num)
{
	icm20602_simiic_start();
    icm20602_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	icm20602_send_ch( reg );   				//ʹӻĴַ

	
	icm20602_simiic_start();
	icm20602_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
    while(--num)
    {
        *dat_add = icm20602_read_ch(ack); //ȡ
        dat_add++;
    }
    *dat_add = icm20602_read_ch(no_ack); //ȡ
	icm20602_simiic_stop();
}

#define icm20602_write_register(reg, dat)        (icm20602_simiic_write_reg(ICM20602_DEV_ADDR, (reg), (dat)))
#define icm20602_write_registers(reg, dat, len)  (icm20602_simiic_write_regs(ICM20602_DEV_ADDR, (reg), (dat), (len)))
#define icm20602_read_register(reg)              (icm20602_simiic_read_reg(ICM20602_DEV_ADDR, (reg)))
#define icm20602_read_registers(reg, dat, len)   (icm20602_simiic_read_regs(ICM20602_DEV_ADDR, (reg), (dat), (len)))

#else

#define ICM20602_SCK(x)				ICM20602_SPC_PIN  = x
#define ICM20602_MOSI(x) 			ICM20602_SDI_PIN = x
#define ICM20602_CS(x)  			ICM20602_CS_PIN  = x
#define ICM20602_MISO    			ICM20602_SDO_PIN 

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ͨSPIдһbyte,ͬʱȡһbyte
//  @param      byte        ͵    
//  @return     uint8       return status״̬
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static uint8 icm20602_simspi_wr_byte(uint8 byte)
{
    uint8 i;
	
    for(i=0; i<8; i++)
    {
        ICM20602_MOSI(byte&0x80);
        byte <<= 1;
		ICM20602_SCK (0);
		ICM20602_SCK (0);
		
		ICM20602_SCK (1);
		ICM20602_SCK (1);
		byte |= ICM20602_MISO; 
    }	
    return(byte);                                      		
}
//-------------------------------------------------------------------------------------------------------------------
//  @brief      valдcmdӦļĴַ,ͬʱstatusֽ
//  @param      cmd         
//  @param      val         дĴֵ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simspi_w_reg_byte(uint8 cmd, uint8 val)
{

    cmd |= ICM20602_SPI_W;
    icm20602_simspi_wr_byte(cmd);                      	
    icm20602_simspi_wr_byte(val);                               	
                                	
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      valдcmdӦļĴַ
//  @param      cmd         
//  @param      val         дĴֵ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
//static void icm20602_simspi_w_reg_bytes(uint8 cmd, uint8 *dat_addr, uint32 len)
//{

//	
//    ICM20602_CS(0);
//    cmd |= ICM20602_SPI_W;
//    icm20602_simspi_wr_byte(cmd);   
//	while(len--)
//	{
//		icm20602_simspi_wr_byte(*dat_addr++); 
//	}                	
//    ICM20602_CS(1);                                    	
//}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡcmdӦļĴַ
//  @param      cmd         
//  @param      *val        洢ȡݵַ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simspi_r_reg_byte(uint8 cmd, uint8 *val)
{

    cmd |= ICM20602_SPI_R;
    icm20602_simspi_wr_byte(cmd);                               	
    *val = icm20602_simspi_wr_byte(0);                           	
                               	
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡcmdӦļĴַ
//  @param      cmd         
//  @param      *val        洢ȡݵַ
//  @param      num         ȡ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_simspi_r_reg_bytes(uint8 cmd, uint8 *val, uint32 num)
{
    uint32 i = 0;
    cmd |= ICM20602_SPI_R;
    icm20602_simspi_wr_byte(cmd);

	while(num--)
	{
		*val++ = icm20602_simspi_wr_byte(0);
	}          
}


//-------------------------------------------------------------------------------------------------------------------
//      IMU660RA дĴ
// ˵     reg             Ĵַ
// ˵     dat            
// ز     void
// ʹʾ     icm20602_write_register(ICM20602_PWR_CONF, 0x00);                   // رո߼ʡģʽ
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_write_register(uint8 reg, uint8 dat)
{
    ICM20602_CS(0);
    icm20602_simspi_w_reg_byte(reg | ICM20602_SPI_W, dat);
    ICM20602_CS(1);
}

//-------------------------------------------------------------------------------------------------------------------
//      IMU660RA д
// ˵     reg             Ĵַ
// ˵     dat            
// ز     void
// ʹʾ     icm20602_write_registers(ICM20602_INIT_dat, icm20602_config_file, sizeof(icm20602_config_file));
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
//static void icm20602_write_registers(uint8 reg, const uint8 *dat, uint32 len)
//{
//    ICM20602_CS(0);
//    icm20602_simspi_w_reg_bytes(reg | ICM20602_SPI_W, dat, len);
//    ICM20602_CS(1);
//}

//-------------------------------------------------------------------------------------------------------------------
//      IMU660RA Ĵ
// ˵     reg             Ĵַ
// ز     uint8           
// ʹʾ     icm20602_read_register(ICM20602_CHIP_ID);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
static uint8 icm20602_read_register(uint8 reg)
{
    uint8 dat;
    ICM20602_CS(0);
    icm20602_simspi_r_reg_byte(reg | ICM20602_SPI_R, &dat);
    ICM20602_CS(1);
    return dat;
}

//-------------------------------------------------------------------------------------------------------------------
//      IMU660RA 
// ˵     reg             Ĵַ
// ˵     dat            ݻ
// ˵     len             ݳ
// ز     void
// ʹʾ     icm20602_read_registers(ICM20602_ACC_ADDRESS, dat, 6);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
static void icm20602_read_registers(uint8 reg, uint8 *dat, uint32 len)
{
    ICM20602_CS(0);
    icm20602_simspi_r_reg_bytes(reg | ICM20602_SPI_R, dat, len);
	ICM20602_CS(1);
}


#endif

//-------------------------------------------------------------------------------------------------------------------
//      ICM20602 Լ
// ˵     void
// ز     uint8           1-Լʧ 0-Լɹ
// ʹʾ     icm20602_self_check();
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
static uint8 icm20602_self_check (void)
{
    uint8 dat = 0, return_state = 0;
    uint16 timeout_count = 0;

    while(0x12 != dat)                                                          // ж ID Ƿȷ
    {
        if(timeout_count ++ > ICM20602_TIMEOUT_COUNT)
        {
            return_state =  1;
            break;
        }
        dat = icm20602_read_register(ICM20602_WHO_AM_I);

        delay_ms(10);
    }
    return return_state;
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡ ICM20602 ٶȼ
// ˵     void
// ز     void
// ʹʾ     icm20602_get_acc();                                             // ִиúֱӲ鿴Ӧı
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void icm20602_get_acc (void)
{
    uint8 dat[6];

    icm20602_read_registers(ICM20602_ACCEL_XOUT_H, dat, 6);
    icm20602_acc_x = (int16)(((uint16)dat[0] << 8 | dat[1]));
    icm20602_acc_y = (int16)(((uint16)dat[2] << 8 | dat[3]));
    icm20602_acc_z = (int16)(((uint16)dat[4] << 8 | dat[5]));
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡICM20602
// ˵     void
// ز     void
// ʹʾ     icm20602_get_gyro();                                            // ִиúֱӲ鿴Ӧı
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void icm20602_get_gyro (void)
{
    uint8 dat[6];

    icm20602_read_registers(ICM20602_GYRO_XOUT_H, dat, 6);
    icm20602_gyro_x = (int16)(((uint16)dat[0] << 8 | dat[1]));
    icm20602_gyro_y = (int16)(((uint16)dat[2] << 8 | dat[3]));
    icm20602_gyro_z = (int16)(((uint16)dat[4] << 8 | dat[5]));
}

//-------------------------------------------------------------------------------------------------------------------
//       ICM20602 ٶȼתΪʵ
// ˵     gyro_value      ļٶȼ
// ز     void
// ʹʾ     float data = icm20602_acc_transition(icm20602_acc_x);           // λΪ g(m/s^2)
// עϢ
//-------------------------------------------------------------------------------------------------------------------
float icm20602_acc_transition (int16 acc_value)
{
    float acc_data = 0;
    switch(ICM20602_ACC_SAMPLE)
    {
        case 0x00: acc_data = (float)acc_value / 16384; break;                  // 0x00 ٶȼΪ:2g     ȡļٶȼ  16384      תΪλݣλg(m/s^2)
        case 0x08: acc_data = (float)acc_value / 8192;  break;                  // 0x08 ٶȼΪ:4g     ȡļٶȼ  8192       תΪλݣλg(m/s^2)
        case 0x10: acc_data = (float)acc_value / 4096;  break;                  // 0x10 ٶȼΪ:8g     ȡļٶȼ  4096       תΪλݣλg(m/s^2)
        case 0x18: acc_data = (float)acc_value / 2048;  break;                  // 0x18 ٶȼΪ:16g    ȡļٶȼ  2048       תΪλݣλg(m/s^2)
        default: break;
    }
    return acc_data;
}

//-------------------------------------------------------------------------------------------------------------------
//       ICM20602 תΪʵ
// ˵     gyro_value      
// ز     void
// ʹʾ     float data = icm20602_gyro_transition(icm20602_gyro_x);         // λΪ/s
// עϢ
//-------------------------------------------------------------------------------------------------------------------
float icm20602_gyro_transition (int16 gyro_value)
{
    float gyro_data = 0;
    switch(ICM20602_GYR_SAMPLE)
    {
        case 0x00: gyro_data = (float)gyro_value / 131.0f;  break;              // 0x00 Ϊ:250 dps     ȡݳ 131           תΪλݣλΪ/s
        case 0x08: gyro_data = (float)gyro_value / 65.5f;   break;              // 0x08 Ϊ:500 dps     ȡݳ 65.5          תΪλݣλΪ/s
        case 0x10: gyro_data = (float)gyro_value / 32.8f;   break;              // 0x10 Ϊ:1000dps     ȡݳ 32.8          תΪλݣλΪ/s
        case 0x18: gyro_data = (float)gyro_value / 16.4f;   break;              // 0x18 Ϊ:2000dps     ȡݳ 16.4          תΪλݣλΪ/s
        default: break;
    }
    return gyro_data;
}

//-------------------------------------------------------------------------------------------------------------------
//      ʼ ICM20602
// ˵     void
// ز     uint8           1-ʼʧ 0-ʼɹ
// ʹʾ     icm20602_init();
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 icm20602_init (void)
{
    uint8 val = 0x0, return_state = 0;
    uint16 timeout_count = 0;

    delay_ms(10);                                                        // ϵʱ

//#if ICM20602_USE_SOFT_IIC
//    soft_iic_init(&icm20602_iic_struct, ICM20602_DEV_ADDR, ICM20602_SOFT_IIC_DELAY, ICM20602_SCL_PIN, ICM20602_SDA_PIN);
//#else
//    spi_init(ICM20602_SPI, SPI_MODE0, ICM20602_SPI_SPEED, ICM20602_SPC_PIN, ICM20602_SDI_PIN, ICM20602_SDO_PIN, SPI_CS_NULL);
//    gpio_init(ICM20602_CS_PIN, GPO, GPIO_HIGH, GPO_PUSH_PULL);
//#endif

    do
    {
        if(icm20602_self_check())
        {
            // ˶Ϣ ʾλ
            // ô ICM20602 Լʱ˳
            // һ½û ûܾǻ
            
//			while(1)
//			{
				printf("icm20602 self check error.");
//				delay_ms(200);
//			}
            return_state = 1;
            break;
        }

        icm20602_write_register(ICM20602_PWR_MGMT_1, 0x80);                     // λ豸
        delay_ms(2);

        do
        {                                                                       // ȴλɹ
            val = icm20602_read_register(ICM20602_PWR_MGMT_1);
            if(timeout_count ++ > ICM20602_TIMEOUT_COUNT)
            {
                // ˶Ϣ ʾλ
                // ô ICM20602 Լʱ˳
                // һ½û ûܾǻ
//				while(1)
//				{
					printf("icm20602 reset error.\r\n");
//					delay_ms(200);
//				}
                return_state = 1;
                break;
            }
        }while(0x41 != val);
        if(1 == return_state)
        {
            break;
        }

        icm20602_write_register(ICM20602_PWR_MGMT_1,     0x01);                 // ʱ
        icm20602_write_register(ICM20602_PWR_MGMT_2,     0x00);                 // Ǻͼٶȼ
        icm20602_write_register(ICM20602_CONFIG,         0x01);                 // 176HZ 1KHZ
        icm20602_write_register(ICM20602_SMPLRT_DIV,     0x07);                 //  SAMPLE_RATE = INTERNAL_SAMPLE_RATE / (1 + SMPLRT_DIV)
        
		icm20602_write_register(ICM20602_GYRO_CONFIG,    ICM20602_GYR_SAMPLE);  // 2000 dps
		// ICM20602_GYRO_CONFIGĴ
        // Ϊ:0x00 Ϊ:250 dps     ȡݳ131           תΪλݣλΪ/s
        // Ϊ:0x08 Ϊ:500 dps     ȡݳ65.5          תΪλݣλΪ/s
        // Ϊ:0x10 Ϊ:1000dps     ȡݳ32.8          תΪλݣλΪ/s
        // Ϊ:0x18 Ϊ:2000dps     ȡݳ16.4          תΪλݣλΪ/s
        
		icm20602_write_register(ICM20602_ACCEL_CONFIG,   ICM20602_ACC_SAMPLE);  // 8g
		// ICM20602_ACCEL_CONFIGĴ
        // Ϊ:0x00 ٶȼΪ:2g          ȡļٶȼ 16384      תΪλݣλg(m/s^2)
        // Ϊ:0x08 ٶȼΪ:4g          ȡļٶȼ 8192       תΪλݣλg(m/s^2)
        // Ϊ:0x10 ٶȼΪ:8g          ȡļٶȼ 4096       תΪλݣλg(m/s^2)
        // Ϊ:0x18 ٶȼΪ:16g         ȡļٶȼ 2048       תΪλݣλg(m/s^2)
       
		icm20602_write_register(ICM20602_ACCEL_CONFIG_2, 0x03);                 // Average 4 samples   44.8HZ   //0x23 Average 16 samples


    }while(0);
    return return_state;
}

