#include "PWM16_mod.h"

void PCA9685_write(u8 address,u8 date)
{                
				simiic_write_reg(PCA9685_adrr,address,date);
}

u8 PCA9685_read(u8 address)
{
		u8 date;
		date =simiic_read_reg(PCA9685_adrr,address,SIMIIC);
    return date;
}
void pwm16_reset(void)
{
    PCA9685_write(PCA9685_MODE1,0x80);
}

void pwm16_begin(void)
{
    pwm16_reset();
}

void setPWMFreq(float freq)
{	
								u8 prescale,oldmode;
								u8 newmode;
                float prescaleval;
                freq *= 0.92;  // Correct for overshoot in the frequency setting
                prescaleval = 25000000;
                prescaleval /= 4096;
                prescaleval /= freq;
                prescaleval -= 1;
                prescale = floor(prescaleval + 0.5);
                 
                oldmode = PCA9685_read(PCA9685_MODE1);
                newmode = (oldmode&0x7F) | 0x10; // sleep
								delay_ms(5);
                PCA9685_write(PCA9685_MODE1, newmode); // go to sleep
								delay_ms(5);
                PCA9685_write(PCA9685_PRESCALE, prescale); // set the prescaler
                delay_ms(5);
								oldmode &= 0xef;
								PCA9685_write(PCA9685_MODE1, oldmode);
                delay_ms(5);
                PCA9685_write(PCA9685_MODE1, oldmode | 0xa1);
}


void PWM16mod_init()
{
	pwm16_begin();
	setPWMFreq(50); 
}

void setPWM(u16 num, u16 on,u16 off)
{
                PCA9685_write(LED0_ON_L+4*num,on);
                PCA9685_write(LED0_ON_H+4*num,on>>8);
                PCA9685_write(LED0_OFF_L+4*num,off);
                PCA9685_write(LED0_OFF_H+4*num,off>>8);
}


/**********************************
 **:set_pwm
 ** :num	AngleýǶ
 **:
 **ֵ:
************************************/
void set_pwm(u8 num,  float Angle)
{
	float off;
	//0-180
	off =(Angle-90.0f)*0.1111f+15;
	//5-25
	if(off<5.0f)off =5.0f;
	else if(off>25.0f) off =25.0f;
  setPWM(num, 0, (int)(off*20.48));
 
}		

//		set_pwm(0,25);


////////////////////////////////////////////////////////////////////////////


Cam_struct Cam;
PTZ_struct PTZ;
/**********************************
 **:PTZ_control
 ** :̨

************************************/
u8 PTZ_control(s16 Angle1,s16 Angle2)
{


		
		//޷
		if(Angle1<20)	Angle1 =20;						//105	Ϊ		
		if(Angle1>170)	Angle1 =170;				
		if(Angle2<90)	Angle2 =90;						//90ǰ
		if(Angle2>112)	Angle2 =112;				//48ͣƺ

		set_pwm(1,Angle1);
		set_pwm(2,Angle2);
		
		return 1;
}


/**********************************
 **:PTZ_Shot
 ** :̨,伤

************************************/
u8 PTZ_Shot()
{
	float err_x,err_y;
	static u32 LastControlTime;
	static float Lasterr_x,Lasterr_y;


		if(time_dly_cnt_ms-LastControlTime <50){		//̫̲B V
			return 0;

		}
	LastControlTime =time_dly_cnt_ms;	
	
	if(Cam.Scan_IfNoPhoto){
		Cam.Scan_IfNoPhoto =0;
		LIGHT =1;
		err_x = Cam.X*0.2f +(Cam.X-Lasterr_x)*0.01f;
		err_y = Cam.Y*0.15f+(Cam.Y-Lasterr_y)*0.015f;
		
		Lasterr_x =Cam.X;
		Lasterr_y =Cam.Y;
		if(err_x>4.0f)	err_x =4.0f;	//޷
		else if(err_x<-4.0f) err_x =-4.0f;	//޷
		if(err_y>4.0f)	err_y =4.0f;	//޷		
		else if(err_y<-4.0f) err_y =-4.0f;	//޷
		PTZ.Angle2 += err_x;
		PTZ.Angle1 -= err_y;	
				
		//޷
		if(PTZ.Angle1<10)	PTZ.Angle1 =10;						//40Ϊ		
		if(PTZ.Angle1>170)	PTZ.Angle1 =170;				
		if(PTZ.Angle2<90)	PTZ.Angle2 =90;						//90ǰ			
		if(PTZ.Angle2>112)	PTZ.Angle2 =112;		

//		USRDate2 =(s16)LastAngle2;
//		USRDate3 =(s16)LastAngle1;		
		//ɽ
//		if(s16abs(Tag.X,0)<10 && s16abs(Tag.Y,0)<10){
//			LIGHT =3;
//			RecolletIfNo =1;
//			return 0;
//		}
		
		return (PTZ_control(PTZ.Angle1,PTZ.Angle2));
	}
	else LIGHT =0;
	return 0;
}


#define PTZ_MINAngle1 10
#define PTZ_MAXAngle1 170
#define PTZ_MINAngle2 120
#define PTZ_MAXAngle2 150

/**********************************
 **:PTZ_AllAngleScan
 ** :ȫǶ
************************************/
u8 PTZ_AllAngleScan()
{
	static s16 LastAngle1=PTZ_MINAngle1,LastAngle2=PTZ_MINAngle2;
	static char DirAngle1=1,DirAngle2=1;
	
	LIGHT =1;
	LastAngle1+=1*DirAngle1;
	if(LastAngle1>PTZ_MAXAngle1){
		DirAngle1	=-1;
		LastAngle2+=4*DirAngle2;
	}
	else if(LastAngle1 <PTZ_MINAngle1){
		DirAngle1 =1;
		LastAngle2+=4*DirAngle2;
	}
	
	if(LastAngle2>PTZ_MAXAngle2){
		DirAngle2 =-1;
	}
	else if(LastAngle2 <PTZ_MINAngle2){
		DirAngle2 =1;
	}
	//ptz
	PTZ.Angle1=LastAngle1;
	PTZ.Angle2=LastAngle2;
	
	
	PTZ_control(LastAngle1,LastAngle2);
	return 1;
}

/**********************************
 **:PTZ_FindTarge
 ** :̨Ŀ꣬ɽ1
************************************/
u8 PTZ_FindTarge()
{
	static u32 Dt;
	if(Cam.Scan_IfNoPhoto ==1){
		
		PTZ_Shot();	//ʽ
		Dt =time_dly_cnt_ms;
		LIGHT =1;
	}
//	else if(time_dly_cnt_ms -Dt >4000)
//		PTZ_AllAngleScan();//ȫǶȼɨ
	else LIGHT =0;
	
	return 0;
}

/**********************************
 **:K210_Tag_Solve
 ** :k210
 **:
 **ֵ:
************************************/
void K210_Cam_Solve()
{
		static float TagXYCol[2][10]={0};
		static s16 x=0;
		
		if(Uart4_ReceiveBuff[0]!=1)		//
			return ;
					if(NowDataWaiting4 ==1)		//ݵ
					{
						NowDataWaiting4 =0;
						if(Uart4_ReceiveBuff[1]==0 &&Uart4_ReceiveBuff[2]==0){		//ûʶ
							TagXYCol[0][x]	=0.98f*TagXYCol[0][(x+9)%10];
							TagXYCol[1][x]	=0.98f*TagXYCol[1][(x+9)%10];								
						
						}
						else{
							TagXYCol[0][x]	=-112+Uart4_ReceiveBuff[1];		
							TagXYCol[1][x]	=-112+Uart4_ReceiveBuff[2];							
						}
				
					}
					else {
							TagXYCol[0][x]	=0.98f*TagXYCol[0][(x+9)%10];
							TagXYCol[1][x]	=0.98f*TagXYCol[1][(x+9)%10];									
					}
	
			
					if(TagXYCol[0][x]-Cam.X>60.0f ||TagXYCol[0][x]-Cam.X<-60.0f)		TagXYCol[0][x] =0.2f*TagXYCol[0][x]+0.5f*TagXYCol[0][(x+9)%10];	//
					if(TagXYCol[1][x]-Cam.X>60.0f ||TagXYCol[1][x]-Cam.X<-60.0f)		TagXYCol[1][x] =0.2f*TagXYCol[1][x]+0.5f*TagXYCol[1][(x+9)%10];	//
			
					if(TagXYCol[0][x]>112)	TagXYCol[0][x]	=112;								//޷
					else if(TagXYCol[0][x]<-112)	TagXYCol[0][x]	=-112;	
					
					if(TagXYCol[1][x]>112)	TagXYCol[1][x]	=112;					
					else if(TagXYCol[1][x]<-112)	TagXYCol[1][x]	=-112;	


					Cam.X =	(s16)(0.5f*(TagXYCol[0][x]	+TagXYCol[0][(x+9)%10] +TagXYCol[0][(x+8)%10])/3 +
											0.3f*(TagXYCol[0][(x+7)%10]	  +TagXYCol[0][(x+6)%10] +TagXYCol[0][(x+5)%10])/3 +
											0.2f*(TagXYCol[0][(x+4)%10]	  +TagXYCol[0][(x+3)%10] +TagXYCol[0][(x+2)%10]+TagXYCol[0][(x+1)%10])/4);

					Cam.Y =	(s16)(0.5f*(TagXYCol[1][x]	+TagXYCol[1][(x+9)%10] +TagXYCol[1][(x+8)%10])/3 +
											0.3f*(TagXYCol[1][(x+7)%10]	  +TagXYCol[1][(x+6)%10] +TagXYCol[1][(x+5)%10])/3 +
											0.2f*(TagXYCol[1][(x+4)%10]	  +TagXYCol[1][(x+3)%10] +TagXYCol[1][(x+2)%10]+TagXYCol[1][(x+1)%10])/4);	
					x++;
					x%=10;

}

//void PTZ_Control()
//{
//	if(PTZ.Mode ==0){			//
//		PTZ_control(PTZ.OriginAngle1,PTZ.OriginAngle2);
//		
//	}
//	else if(PTZ.Mode ==1)	//Ѱ
//	{
//		PTZ_AllAngleScan();
//	}


//}


	