/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		eeprom
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/
#include "zf_eeprom.h"
#include "board.h"
#include "intrins.h"


//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROM
//  @param      
//  @return     void
//  Sample usage:       		ڲʹû
//-------------------------------------------------------------------------------------------------------------------
void eeprom_trig(void)
{
    F0 = EA;    //ȫж
    EA = 0;     //ֹж, ⴥЧ
    IAP_TRIG = 0x5A;
    IAP_TRIG = 0xA5;                    //5AHA5HIAPĴÿζҪ
                                        //A5HIAP
                                        //CPUȴIAPɺ󣬲Żִг
    _nop_();   //STC32GǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
    _nop_();
    _nop_();
    _nop_();
    EA = F0;    //ָȫж
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼEEPROM
//  @param      NULL
//  @return     void
//  Sample usage:           
//-------------------------------------------------------------------------------------------------------------------
void iap_init(void)
{
	IAP_CONTR |= 1<<7;	 	//ʹEEPROM
	iap_set_tps();			//òȴʱ
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      رEEPROM
//  @param      NULL
//  @return     void
//  Sample usage:           
//-------------------------------------------------------------------------------------------------------------------
void iap_idle(void)
{
	IAP_CONTR &= ~(1<<7);//ʧEEPROM
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡEEPROMʧ״̬λҪ
//  @param      NULL
//  @return     void
//  Sample usage:           
//								ʧܷ1;
//-------------------------------------------------------------------------------------------------------------------
uint8 iap_get_cmd_state(void)
{
	return ((IAP_CONTR&0x01) == 0x01);
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      IAPȴʱ
//  @param      NULL
//  @return     void
//  Sample usage:           
//-------------------------------------------------------------------------------------------------------------------
void iap_set_tps(void)
{
	uint8 write_time;
	write_time = (sys_clk / 1000000) + 1;
	IAP_TPS = write_time;
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMȡֽ
//  @param      addr			Ҫȡeepromַ
//  @param      *buf			Ҫȡݵַ
//  @param      len				Ҫȡݳ
//  @return     void
//  Sample usage:               uint8 str[10];
//								iap_read_bytes(0x00,str,10);
//								0x00-0x0AַеݣȡstrС
//-------------------------------------------------------------------------------------------------------------------
void iap_read_bytes(uint16 addr, uint8 *buf, uint16 len)
{
	IAP_CMD = 1; 				// IAP 	

	while(len--)
	{
        IAP_ADDRE = 0;
		IAP_ADDRL = addr; 		// IAP ͵ַ
		IAP_ADDRH = addr >> 8; 	// IAP ߵַ
        eeprom_trig();
		*buf++ = IAP_DATA; 		// IAP 
		addr++;
		
	}
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMдֽ
//  @param      addr			Ҫдeepromַ
//  @param      *buf			Ҫдݵַ
//  @param      len				Ҫдݳ
//  @return     void
//  Sample usage:       		iap_write_bytes(0x00,(uint8 *)"0123456789",10);
//								"0123456789"д0x00-0x0Aַ;
//-------------------------------------------------------------------------------------------------------------------
void iap_write_bytes(uint16 addr, uint8 *buf, uint16 len)
{
	IAP_CMD = 2; 				// IAP 	
	
	while(len--)
	{
        IAP_ADDRE = 0;
		IAP_ADDRL = addr; 		// IAP ͵ַ
		IAP_ADDRH = addr >> 8; 	// IAP ߵַ
		IAP_DATA = *buf++; 		//д IAP 
		addr++;

		eeprom_trig();
	}
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMĿַڵһҳ1/512ֽڣ
//  @param      addr			Ҫдeepromַ
//  @return     void
//  Sample usage:       		iap_erase(0x20);
//								0x00-0x200
//-------------------------------------------------------------------------------------------------------------------
void iap_erase_page(uint16 addr) 
{ 
	IAP_CMD = 3; 				// IAP 
	IAP_ADDRL = addr; 			// IAP ͵ַ
	IAP_ADDRH = addr >> 8;  	// IAP ߵַ
    eeprom_trig();

}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      չEEPROMдֽ()
//  @param      addr			Ҫдeepromַ
//  @param      *buf			Ҫдݵַ
//  @param      len				Ҫдݳ
//  @return     void
//  Sample usage:       		extern_iap_write_bytes(0x0000,(uint8 *)"0123456789";,10);
//								"0123456789"д0x00-0x0Aַ;
//	@note						Ҫʹá
//								addrַ0-511Ϊһ,512-1023Ϊһ1024-1035Ϊһơ
//-------------------------------------------------------------------------------------------------------------------
void extern_iap_write_bytes(uint16 addr, uint8 *buf, uint16 len)
{ 
	uint8 temp[512];
	uint16 i;
	
	for(i=0; i<512 ;i++)	temp[i] = 0;			//0
	iap_read_bytes(addr&0xFE00, temp, 512);			//ȡ
	for(i=0; i<len; i++)	temp[(addr&0x1FF) + i] = buf[i];	//
	iap_erase_page(addr);							//
	iap_write_bytes(addr&0xFE00, temp, 512);		//д
}


