/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		pwm
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK5.27
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/

#include "zf_pwm.h"
#include "board.h"
#include "zf_gpio.h"
#include "zf_uart.h"
#include "stdio.h"


//#pragma warning disable = 208


//ȽģʽĴ
const uint32 PWM_CCMR_ADDR[] = {0x7efec8, 0x7efec9, 0x7efeca ,0x7efecb, 
								0x7efee8, 0x7efee9, 0x7efeea, 0x7efeeb};
//ȽʹܼĴ
const uint32 PWM_CCER_ADDR[] = {0x7efecc, 0x7efecd, 
								0x7efeec ,0x7efeed};
//ƼĴ,8λַ  8λַ + 1
const uint32 PWM_CCR_ADDR[] = {0x7efed5, 0x7efed7, 0x7efed9, 0x7efedb,
							   0x7efef5, 0x7efef7, 0x7efef9, 0x7efefb};
	
							   //ƼĴ,8λַ  8λַ + 1
const uint32 PWM_ARR_ADDR[] = {0x7efed2,0x7efef2};

//-------------------------------------------------------------------------------------------------------------------
//  @brief      PWM_gpioʼڲʹûģ
//  @param      pwmch       PWMͨż
//  @return     void
//  Sample usage:           
//-------------------------------------------------------------------------------------------------------------------
void pwm_set_gpio(PWMCH_enum pwmch)
{
	switch(pwmch)
	{
		case PWMA_CH1P_P10:
		{
			gpio_mode(P1_0,GPO_PP);
			break;
		}
		case PWMA_CH1N_P11:
		{
			gpio_mode(P1_1,GPO_PP);
			break;
		}
		case PWMA_CH1P_P20:
		{
			gpio_mode(P2_0,GPO_PP);
			break;
		}
		case PWMA_CH1N_P21:
		{
			gpio_mode(P2_1,GPO_PP);
			break;
		}
		case PWMA_CH1P_P60:
		{
			gpio_mode(P6_0,GPO_PP);
			break;
		}
		case PWMA_CH1N_P61:
		{
			gpio_mode(P6_1,GPO_PP);
			break;
		}
		
		case PWMA_CH2P_P12:
		{
			gpio_mode(P1_2,GPO_PP);
			break;
		}
		case PWMA_CH2N_P13:
		{
			gpio_mode(P1_3,GPO_PP);
			break;
		}
		case PWMA_CH2P_P22:
		{
			gpio_mode(P2_2,GPO_PP);
			break;
		}
		case PWMA_CH2N_P23:
		{
			gpio_mode(P2_3,GPO_PP);
			break;
		}
		case PWMA_CH2P_P62:
		{
			gpio_mode(P6_2,GPO_PP);
			break;
		}
		case PWMA_CH2N_P63:
		{
			gpio_mode(P6_3,GPO_PP);
			break;
		}
		
		case PWMA_CH3P_P14:
		{
			gpio_mode(P1_4,GPO_PP);
			break;
		}
		case PWMA_CH3N_P15:
		{
			gpio_mode(P1_5,GPO_PP);
			break;
		}
		case PWMA_CH3P_P24:
		{
			gpio_mode(P2_4,GPO_PP);
			break;
		}
		case PWMA_CH3N_P25:
		{
			gpio_mode(P2_5,GPO_PP);
			break;
		}
		case PWMA_CH3P_P64:
		{
			gpio_mode(P6_4,GPO_PP);
			break;
		}
		case PWMA_CH3N_P65:
		{
			gpio_mode(P6_5,GPO_PP);
			break;
		}
		
		
		case PWMA_CH4P_P16:
		{
			gpio_mode(P1_6,GPO_PP);
			break;
		}
		case PWMA_CH4N_P17:
		{
			gpio_mode(P1_7,GPO_PP);
			break;
		}
		case PWMA_CH4P_P26:
		{
			gpio_mode(P2_6,GPO_PP);
			break;
		}
		case PWMA_CH4N_P27:
		{
			gpio_mode(P2_7,GPO_PP);
			break;
		}
		case PWMA_CH4P_P66:
		{
			gpio_mode(P6_6,GPO_PP);
			break;
		}
		case PWMA_CH4N_P67:
		{
			gpio_mode(P6_7,GPO_PP);
			break;
		}
		case PWMA_CH4P_P34:
		{
			gpio_mode(P3_4,GPO_PP);
			break;
		}
		case PWMA_CH4N_P33:
		{
			gpio_mode(P3_3,GPO_PP);
			break;
		}
		
		
		case PWMB_CH1_P20:
		{
			gpio_mode(P2_0,GPO_PP);
			break;
		}
		case PWMB_CH1_P17:
		{
			gpio_mode(P1_7,GPO_PP);
			break;
		}
		case PWMB_CH1_P00:
		{
			gpio_mode(P0_0,GPO_PP);
			break;
		}
		case PWMB_CH1_P74:
		{
			gpio_mode(P7_4,GPO_PP);
			break;
		}
		
		case PWMB_CH2_P21:
		{
			gpio_mode(P2_1,GPO_PP);
			break;
		}
		case PWMB_CH2_P54:
		{
			gpio_mode(P5_4,GPO_PP);
			break;
		}
		case PWMB_CH2_P01:
		{
			gpio_mode(P0_1,GPO_PP);
			break;
		}
		case PWMB_CH2_P75:
		{
			gpio_mode(P7_5,GPO_PP);
			break;
		}

		
		case PWMB_CH3_P22:
		{
			gpio_mode(P2_2,GPO_PP);
			break;
		}
		case PWMB_CH3_P33:
		{
			gpio_mode(P3_3,GPO_PP);
			break;
		}
		case PWMB_CH3_P02:
		{
			gpio_mode(P0_2,GPO_PP);
			break;
		}
		case PWMB_CH3_P76:
		{
			gpio_mode(P7_6,GPO_PP);
			break;
		}

		
		case PWMB_CH4_P23:
		{
			gpio_mode(P2_3,GPO_PP);
			break;
		}
		case PWMB_CH4_P34:
		{
			gpio_mode(P3_4,GPO_PP);
			break;
		}
		case PWMB_CH4_P03:
		{
			gpio_mode(P0_3,GPO_PP);
			break;
		}
		case PWMB_CH4_P77:
		{
			gpio_mode(P7_7,GPO_PP);
			break;
		}
		
	}
	
}
	
		
//-------------------------------------------------------------------------------------------------------------------
//  @brief      PWMʼ
//  @param      pwmch       PWMͨż
//  @param      freq        PWMƵ(10Hz-3MHz)
//  @param      duty        PWMռձ
//  @return     void
//  Sample usage:           
//							pwm_init(PWM0_P00, 100, 5000);     //ʼPWM0  ʹP0.0  PWMƵ100HZ   ռձΪٷ֮ 5000/PWM_DUTY_MAX*100
//							PWM_DUTY_MAXzf_pwm.hļ ĬΪ10000
//-------------------------------------------------------------------------------------------------------------------
void pwm_init(PWMCH_enum pwmch,uint32 freq, uint32 duty)
{
	
	uint32 match_temp;
	uint32 period_temp; 
	uint16 freq_div = 0;
	
	
	P_SW2 |= 0x80;
	
	//GPIOҪΪ
	pwm_set_gpio(pwmch);


	//Ƶ㣬ڼ㣬ռձȼ
	freq_div = (sys_clk / freq) >> 16;							//ٷƵ
	period_temp = sys_clk / freq ;			
	period_temp = period_temp / (freq_div + 1) - 1;				//

	match_temp = period_temp * ((float)duty / PWM_DUTY_MAX);	//ռձ

	
	if(PWMB_CH1_P20 <= pwmch)				//PWM5-8
	{
		//ͨѡѡ
		PWMB_ENO |= (1 << ((2 * ((pwmch >> 4) - 4))));					//ʹͨ	
		PWMB_PS |= ((pwmch & 0x03) << ((2 * ((pwmch >> 4) - 4))));		//ѡ
		
		// ͨʹܺͼ	
		(*(unsigned char volatile far *) (PWM_CCER_ADDR[pwmch>>5])) |= (uint8)(1 << (((pwmch >> 4) & 0x01) * 4));
		
		//ԤƵ
		PWMB_PSCRH = (uint8)(freq_div>>8);
		PWMB_PSCRL = (uint8)freq_div;
		
		PWMB_BKR = 0x80; 	//ʹ ൱ܿ
		PWMB_CR1 = 0x01;	//PWMʼ
	}
	else
	{
		PWMA_ENO |= (1 << (pwmch & 0x01)) << ((pwmch >> 4) * 2);	//ʹͨ	
		PWMA_PS  |= ((pwmch & 0x07) >> 1) << ((pwmch >> 4) * 2);    //ѡ
		
		// ͨʹܺͼ	
		(*(unsigned char volatile far *) (PWM_CCER_ADDR[pwmch>>5])) |= (1 << ((pwmch & 0x01) * 2 + ((pwmch >> 4) & 0x01) * 0x04));

		
		//ԤƵ
		PWMA_PSCRH = (uint8)(freq_div>>8);
		PWMA_PSCRL = (uint8)freq_div;

		PWMA_BKR = 0x80; 	// ʹ ൱ܿ
		PWMA_CR1 = 0x01;	//PWMʼ
	}
	
	//
	(*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6])) = (uint8)(period_temp>>8);		//8λ
	(*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6] + 1)) = (uint8)period_temp;		//8λ

	//òֵ|Ƚֵ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4]))		= match_temp>>8;			//8λ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4] + 1))  = (uint8)match_temp;		//8λ
	
	//
	(*(unsigned char volatile far *) (PWM_CCMR_ADDR[pwmch>>4])) |= 0x06<<4;		//ΪPWMģʽ1
	(*(unsigned char volatile far *) (PWM_CCMR_ADDR[pwmch>>4])) |= 1<<3;		//PWMĴԤװع
	

//	P_SW2 &= 0x7F;

}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      PWMռձ
//  @param      pwmch       PWMͨż
//  @param      duty        PWMռձ
//  @return     void
//  Sample usage:           pwm_duty(PWM0_P00, 5000);     //ʼPWM0  ʹP0.0  PWMƵ50HZ   ռձΪٷ֮ 5000/PWM_DUTY_MAX*100
//							PWM_DUTY_MAXfsl_pwm.hļ ĬΪ10000
//-------------------------------------------------------------------------------------------------------------------
void pwm_duty(PWMCH_enum pwmch, uint32 duty)
{
	uint32 match_temp;
	uint32 arr = ((*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6]))<<8) | (*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6] + 1 ));

//	P_SW2 |= 0x80;

	match_temp = arr * ((float)duty/PWM_DUTY_MAX);				//ռձ
							
	
	//òֵ|Ƚֵ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4]))		= match_temp>>8;			//8λ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4] + 1))  = (uint8)match_temp;		//8λ

//	P_SW2 &= ~0x80;
	
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      PWMƵ
//  @param      pwmch       PWMͨż
//  @param      freq        PWMƵ(10Hz-3MHz)
//  @param      duty        PWMռձ
//  @return     void
//  Sample usage:           pwm_freq(PWM0_P00, 50, 5000);     //޸ĻPWM0  ʹP0.0  PWMƵ50HZ   ռձΪٷ֮ 5000/PWM_DUTY_MAX*100
//-------------------------------------------------------------------------------------------------------------------
void pwm_freq(PWMCH_enum pwmch, uint32 freq, uint32 duty)
{
	uint32 match_temp;
    uint32 period_temp; 
	uint16 freq_div = 0;

	

	//Ƶ㣬ڼ㣬ռձȼ
	freq_div = (sys_clk / freq) >> 16;							//ٷƵ
	period_temp = sys_clk / freq;			
	period_temp = period_temp / (freq_div + 1) - 1;				//
	
	match_temp = period_temp * ((float)duty / PWM_DUTY_MAX);	//ռձ
	
//	P_SW2 |= 0x80;
	
	if(PWMB_CH1_P20 <= pwmch)				//PWM5-8
	{
		//ԤƵ
		PWMB_PSCRH = (uint8)(freq_div>>8);
		PWMB_PSCRL = (uint8)freq_div;
	}
	else
	{
		//ԤƵ
		PWMA_PSCRH = (uint8)(freq_div>>8);
		PWMA_PSCRL = (uint8)freq_div;
	}
	
	//
	(*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6])) = (uint8)(period_temp>>8);		//8λ
	(*(unsigned char volatile far *) (PWM_ARR_ADDR[pwmch>>6] + 1)) = (uint8)period_temp;		//8λ
	
		//òֵ|Ƚֵ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4]))		= match_temp>>8;			//8λ
	(*(unsigned char volatile far *) (PWM_CCR_ADDR[pwmch>>4] + 1))  = (uint8)match_temp;		//8λ
	
//	P_SW2 &= ~0x80;
}


