/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2020,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897()  Ⱥ824575535
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		spi
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ790875685)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-4-14
 ********************************************************************************************************************/
#pragma warning disable = 47

#include "zf_gpio.h"
#include "zf_spi.h"



//-------------------------------------------------------------------------------------------------------------------
//  @brief      spiʼ(ss)
//  @param      spi_n			ѡSPIģ(SPI_1-SPI_4)
//  @param      sck_pin			ѡSCK
//  @param      mosi_pin		ѡMOSI
//  @param      miso_pin		ѡMISO
//  @param     	mstr			ѡ
//  @param      mode            SPIģʽ 0CPOL=0 CPHA=0    1CPOL=0 CPHA=1   2CPOL=1 CPHA=0   3CPOL=1 CPHA=1 //ϸڿаٶ
//  @param     	baud			ѡ
//  @since      v1.0
//  Sample usage:				spi_init(SPI_1, SPI1_SCLK_P15, SPI1_MOSI_P13, SPI1_MISO_P14, 0, MASTER, SYSclk_DIV_4);	
//								//ʼSPI1,ģʽ,ΪϵͳƵ/4SCLKP1.5 MOSIP1.3 MISOP1.4,SPIģʽ0
//-------------------------------------------------------------------------------------------------------------------
void spi_init(SPIN_enum spi_n,
			  SPI_PIN_enum sck_pin, 
			  SPI_PIN_enum mosi_pin, 
			  SPI_PIN_enum miso_pin, 
			  uint8 mode,
			  SPI_MSTR_enum mstr,
			  SPI_BAUD_enum baud)
{
	switch(spi_n)
    {
	//IOҪΪ׼˫ڣͳ8051˿ģʽ
    case SPI_CH1:
		gpio_mode(P1_3,GPIO);
		gpio_mode(P1_4,GPIO);
		gpio_mode(P1_5,GPIO);
        break;
    case SPI_CH2:
		gpio_mode(P2_3,GPIO);
		gpio_mode(P2_4,GPIO);
		gpio_mode(P2_5,GPIO);
        break;
    case SPI_CH3:
		gpio_mode(P4_0,GPIO);
		gpio_mode(P4_1,GPIO);
		gpio_mode(P4_3,GPIO);
        break;
    case SPI_CH4:
		gpio_mode(P3_4,GPIO);
		gpio_mode(P3_3,GPIO);
		gpio_mode(P3_2,GPIO);
        break;
    }
	
	P_SW1 &= ~(0x03<<2);  //SPIܽѡλ
    switch(spi_n)
    {
    case SPI_CH1:
        P_SW1 |= (0x00<<2);
        break;
    case SPI_CH2:
        P_SW1 |= (0x01<<2);
        break;
    case SPI_CH3:
        P_SW1 |= (0x02<<2);
        break;
    case SPI_CH4:
        P_SW1 |= (0x03<<2);
        break;
    }
	
	SPCTL &= 0xF3;		//SPIԺλ
	switch(mode)
	{
	case 0:
		
		break;
	case 1:
		SPCTL |= 0x01<<2;
		break;
	case 2:
		SPCTL |= 0x02<<2;
		break;
	case 3:
		SPCTL |= 0x03<<2;
		break;
	}
		
	
	SPCTL |= baud;		//趨

    if(mstr == MASTER)
    {
        SPCTL |= 1<<7;	//SSŹܣʹMSTRȷǴӻ
        SPCTL |= 1<<4;	//ģʽ
    }
    else
    {
        //
    }
    SPCTL |= 1<<6;		//ʹSPI
		

}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      SPIͽպ
//  @param      dat          	͵
//  @since      v1.0
//  Sample usage:				buf_1 = spi_mosi(buf);    //bufݣյbuf_1Ϊ1ֽ
//-------------------------------------------------------------------------------------------------------------------
uint8 spi_mosi(uint8 dat)
{
    SPDAT = dat;					//DATAĴֵ
    while (!(SPSTAT & 0x80));  		//ѯɱ־
    SPSTAT = 0xc0;                  //жϱ־
	return SPDAT;
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      spiл(ss)
//  @param      spi_n			ѡSPIģ(SPI_1-SPI_4)
//  @param      sck_pin			ѡSCK
//  @param      mosi_pin		ѡMOSI
//  @param      miso_pin		ѡMISO
//  Sample usage:				spi_change_pin(SPI_1,SPI1_SCLK_P15, SPI1_MOSI_P13,SPI1_MISO_P14);	
//								//лSPI
//-------------------------------------------------------------------------------------------------------------------
void spi_change_pin(SPIN_enum spi_n, SPI_PIN_enum sck_pin, SPI_PIN_enum mosi_pin, SPI_PIN_enum miso_pin)
{
    P_SW1 &= ~(0x03<<2);  //SPIܽѡλ
	switch(spi_n)
    {
	//IOҪΪ׼˫ڣͳ8051˿ģʽ
    case SPI_CH1:
		gpio_mode(P1_3,GPO_PP);
		gpio_mode(P1_4,GPIO);
		gpio_mode(P1_5,GPO_PP);
        break;
    case SPI_CH2:
		gpio_mode(P2_3,GPO_PP);
		gpio_mode(P2_4,GPIO);
		gpio_mode(P2_5,GPO_PP);
        break;
    case SPI_CH3:
		gpio_mode(P4_0,GPO_PP);
		gpio_mode(P4_1,GPIO);
		gpio_mode(P4_3,GPO_PP);
        break;
    case SPI_CH4:
		gpio_mode(P3_4,GPO_PP);
		gpio_mode(P3_3,GPIO);
		gpio_mode(P3_2,GPO_PP);
        break;
    }
	

    switch(spi_n)
    {
    case SPI_CH1:
        P_SW1 |= (0x00<<2);
        break;
    case SPI_CH2:
        P_SW1 |= (0x01<<2);
        break;
    case SPI_CH3:
        P_SW1 |= (0x02<<2);
        break;
    case SPI_CH4:
        P_SW1 |= (0x03<<2);
        break;
    }
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      spiģʽл
//  @param      mode            SPIģʽ 0CPOL=0 CPHA=0    1CPOL=0 CPHA=1   2CPOL=1 CPHA=0   3CPOL=1 CPHA=1 //ϸڿаٶ
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void spi_change_mode(uint8 mode)
{
	SPCTL &= 0xF7;		//SPIԺλ
	switch(mode)
	{
	case 0:
		
		break;
	case 1:
		SPCTL |= 0x01<<2;
		break;
	case 2:
		SPCTL |= 0x02<<2;
		break;
	case 3:
		SPCTL |= 0x03<<2;
		break;
	}
}
