#include "PWM16_mod.h"

void PCA9685_write(u8 address,u8 date)
{                
				simiic_write_reg(PCA9685_adrr,address,date);
}

u8 PCA9685_read(u8 address)
{
		u8 date;
		date =simiic_read_reg(PCA9685_adrr,address,SIMIIC);
    return date;
}
void pwm16_reset(void)
{
    PCA9685_write(PCA9685_MODE1,0x80);
}

void pwm16_begin(void)
{
    pwm16_reset();
}

void setPWMFreq(float freq)
{	
								u16 prescale,oldmode,newmode;
                float prescaleval;
                freq *= 0.92;  // Correct for overshoot in the frequency setting
                prescaleval = 25000000;
                prescaleval /= 4096;
                prescaleval /= freq;
                prescaleval -= 1;
                prescale = floor(prescaleval + 0.5);
                 
                oldmode = PCA9685_read(PCA9685_MODE1);
                newmode = (oldmode&0x7F) | 0x10; // sleep
								delay_ms(5);
                PCA9685_write(PCA9685_MODE1, newmode); // go to sleep
								delay_ms(5);
                PCA9685_write(PCA9685_PRESCALE, prescale); // set the prescaler
                delay_ms(5);
								oldmode &= 0xef;
								PCA9685_write(PCA9685_MODE1, oldmode);
                delay_ms(5);
                PCA9685_write(PCA9685_MODE1, oldmode | 0xa1);
}


void PWM16mod_init()
{
	pwm16_begin();
	setPWMFreq(50); 
}

void setPWM(u16 num, u16 on,u16 off)
{
                PCA9685_write(LED0_ON_L+4*num,on);
                PCA9685_write(LED0_ON_H+4*num,on>>8);
                PCA9685_write(LED0_OFF_L+4*num,off);
                PCA9685_write(LED0_OFF_H+4*num,off>>8);
}

void set_pwm(u8 num,  float Angle)
{
	float off;
	//Angle:0-180
	off =(Angle-90.0f)*0.1111f+15;
	//off:5-25
	if(off<5.0f)off =5.0f;
	else if(off>25.0f) off =25.0f;
  setPWM(num, 0, (int)(off*20.48));		//  ù  5-25ڱ
 
}		

//		set_pwm(0,25);