/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2018,ɿƼ
 * All rights reserved.
 * QQȺ179029047
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		ʽ
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ3184284598)
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2020-01-13
 * @note		
					߶壺
					------------------------------------ 
					ģܽ            Ƭܽ
					SCK    			    鿴SEEKFREE_ABSOLUTE_ENCODER.HļABS_ENCODER_SPI_SCK_PIN 궨
					MISO         	    鿴SEEKFREE_ABSOLUTE_ENCODER.HļABS_ENCODER_SPI_MISO_PIN궨
					MOSI                鿴SEEKFREE_ABSOLUTE_ENCODER.HļABS_ENCODER_SPI_MOSI_PIN궨
					CS                  鿴SEEKFREE_ABSOLUTE_ENCODER.HļABS_ENCODER_SPI_PCS_PIN  궨
					------------------------------------  
 ********************************************************************************************************************/

#include "SEEKFREE_ABSOLUTE_ENCODER.h"
#include "zf_spi.h"
#include "zf_delay.h"


//-------------------------ΪSPI--------------------------//
//-------------------------ΪSPI--------------------------//
//-------------------------ΪSPI--------------------------//

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ڲʹû
//  @param      NULL            	
//  @return     void
//  Sample usage:               ûãûʹhļеĺ궨
//-------------------------------------------------------------------------------------------------------------------
void encoder_delay_us(uint16 x)
{
	delay_us(x);
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ͨSPIдһbyte,ͬʱȡһbyte
//  @param      byte        ͵    
//  @return     uint8       return status״̬
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint8 simspi_wr_byte(uint8 byte)
{
    uint8 i;
    for(i=0; i<8; i++)
    {
        ABS_ENCODER_MOSI(byte & 0x80);
        byte <<= 1;
        ABS_ENCODER_SCK (0);    
      
        ABS_ENCODER_SCK (1);
		byte |= ABS_ENCODER_MISO;  
    }	
    return(byte);                                      		
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      valдcmdӦļĴַ,ͬʱstatusֽ
//  @param      cmd         
//  @param      val         дĴֵ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void simspi_w_reg_byte(uint8 cmd, uint8 val)
{
    ABS_ENCODER_CSN (0);
    cmd |= ABS_ENCODER_SPI_W;
    simspi_wr_byte(cmd);                      	
    simspi_wr_byte(val);                               	
    ABS_ENCODER_CSN (1);                                    	
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡcmdӦļĴַ
//  @param      cmd         
//  @param      *val        洢ȡݵַ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void simspi_r_reg_byte(uint8 cmd, uint8 *val)
{
    ABS_ENCODER_CSN (0);
    cmd |= ABS_ENCODER_SPI_R;
    simspi_wr_byte(cmd);                               	
    *val = simspi_wr_byte(0);                           	
    ABS_ENCODER_CSN (1);                                    	
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      дһݵļĴ
//  @param      cmd         Ĵַ
//  @param      *val        дݵĵַ
//  @return     uint8       0  1ʧ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint8 encoder_simspi_w_reg_byte(uint8 cmd, uint8 val)
{
	
    uint8 dat;
    ABS_ENCODER_CSN (0);
    cmd |= ABS_ENCODER_SPI_W;
    simspi_wr_byte(cmd);                      	
    simspi_wr_byte(val);                               	
    ABS_ENCODER_CSN (1);   
    encoder_delay_us(1);
    ABS_ENCODER_CSN (0);
    dat = simspi_wr_byte(0x00);                      	
    simspi_wr_byte(0x00);                               	
    ABS_ENCODER_CSN (1);  
    
    if(val != dat)  return 1;   //дʧ
    return 0;                   //дɹ
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡĴ
//  @param      cmd         Ĵַ
//  @param      *val        洢ȡݵַ
//  @return     void
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void encoder_simspi_r_reg_byte(uint8 cmd, uint8 *val)
{
    ABS_ENCODER_CSN (0);
    cmd |= ABS_ENCODER_SPI_R;
    simspi_wr_byte(cmd);                      	
    simspi_wr_byte(0x00);                               	
    ABS_ENCODER_CSN (1);   
	encoder_delay_us(1);
    ABS_ENCODER_CSN (0);
    *val = simspi_wr_byte(0x00);                      	
    simspi_wr_byte(0x00);                               	
    ABS_ENCODER_CSN (1);
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ƫ
//  @param      zero_position  Ҫõƫ
//  @return     void
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void set_zero_position_simspi(uint16 zero_position)
{    
    zero_position = (uint16)(4096 - zero_position);
    zero_position = zero_position << 4;
    encoder_simspi_w_reg_byte(ZERO_L_REG,(uint8)zero_position);//λ
    encoder_simspi_w_reg_byte(ZERO_H_REG,(uint8)(zero_position>>8));
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      дһݵļĴ
//  @param      void
//  @return     uint16       ؽǶֵ0-4096 Ӧ0-360
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint16 encoder_angle_simspi(void)
{
    uint16 angle;

    ABS_ENCODER_CSN (0);
    angle = simspi_wr_byte(0x00);      
    angle <<= 8;                    //洢߰λ
    angle |= simspi_wr_byte(0x00);  //洢Ͱλ
    ABS_ENCODER_CSN (1);   
    
    return (angle>>4);              //12λȣλ                 
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      Լ캯
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void encoder_self4_check(void)
{
    uint8 val;
    do
    {
        encoder_simspi_r_reg_byte(6,&val);
	
        //ԭ¼
        //1 ˣµĸʼ
        //2 ߴûнӺ
    }while(0x1C != val);
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼ
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void encoder_init_simspi(void)
{
    encoder_self4_check();					//Լ
    
    encoder_simspi_w_reg_byte(DIR_REG,0x00);//ת תֵС0x00   תֵ0x80

    set_zero_position_simspi(0);             //ƫ
}


//-------------------------ΪSPI--------------------------//
//-------------------------ΪSPI--------------------------//
//-------------------------ΪSPI--------------------------//


//-------------------------ΪӲSPI--------------------------//
//-------------------------ΪӲSPI--------------------------//
//-------------------------ΪӲSPI--------------------------//

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ͨSPIдһbyte,ͬʱȡһbyte
//  @param      byte        ͵    
//  @return     uint8       return status״̬
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint8 spi_wr_byte(uint8 byte)
{  
	byte = spi_mosi(byte);
	return(byte);   
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      valдcmdӦļĴַ,ͬʱstatusֽ
//  @param      cmd         
//  @param      val         дĴֵ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void spi_w_reg_byte(uint8 cmd, uint8 val)
{
    ABS_ENCODER_SPI_CSN (0);
    cmd |= ABS_ENCODER_SPI_W;
    spi_wr_byte(cmd);                      	
    spi_wr_byte(val);                               	
    ABS_ENCODER_SPI_CSN (1);       
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡcmdӦļĴַ
//  @param      cmd         
//  @param      *val        洢ȡݵַ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void spi_r_reg_byte(uint8 cmd, uint8 *val)
{
    ABS_ENCODER_SPI_CSN (0);
    cmd |= ABS_ENCODER_SPI_R;
    spi_wr_byte(cmd);                               	
    *val = simspi_wr_byte(0);                           	
    ABS_ENCODER_SPI_CSN (1);                                    	
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      дһݵļĴ
//  @param      cmd         Ĵַ
//  @param      *val        дݵĵַ
//  @return     uint8       0  1ʧ
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint8 encoder_spi_w_reg_byte(uint8 cmd, uint8 val)
{
    uint8 dat;
    ABS_ENCODER_SPI_CSN (0);
    cmd |= ABS_ENCODER_SPI_W;
    spi_wr_byte(cmd);                      	
    spi_wr_byte(val);                               	
    ABS_ENCODER_SPI_CSN (1);   
	encoder_delay_us(1);
    ABS_ENCODER_SPI_CSN (0);
    dat = spi_wr_byte(0x00);                      	
    spi_wr_byte(0x00);                               	
    ABS_ENCODER_SPI_CSN (1);  
    
    if(val != dat)  return 1;   //дʧ
    return 0;                   //дɹ
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡĴ
//  @param      cmd         Ĵַ
//  @param      *val        洢ȡݵַ
//  @return     void
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void encoder_spi_r_reg_byte(uint8 cmd, uint8 *val)
{
    ABS_ENCODER_SPI_CSN (0);
    cmd |= ABS_ENCODER_SPI_R;
    spi_wr_byte(cmd);                      	
    spi_wr_byte(0x00);   

    ABS_ENCODER_SPI_CSN (1);   
	encoder_delay_us(1);
    ABS_ENCODER_SPI_CSN (0);
    *val = spi_wr_byte(0x00);                      	
    spi_wr_byte(0x00);                               	
    ABS_ENCODER_SPI_CSN (1);
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ƫ
//  @param      zero_position  Ҫõƫ
//  @return     void
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void set_zero_position_spi(uint16 zero_position)
{    
    zero_position = (uint16)(4096 - zero_position);
    zero_position = zero_position << 4;
    encoder_spi_w_reg_byte(ZERO_L_REG,(uint8)zero_position);//λ
    encoder_spi_w_reg_byte(ZERO_H_REG,(uint8)(zero_position>>8));
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      дһݵļĴ
//  @param      void
//  @return     uint16       ؽǶֵ0-4096 Ӧ0-360
//  @since      v1.0
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint16 encoder_angle_spi(void)
{
    uint16 angle;
    ABS_ENCODER_SPI_CSN (0);
    angle = (uint16)spi_wr_byte(0x00);      
    angle <<= 8;                    //洢߰λ
    angle |= (uint16)spi_wr_byte(0x00);  //洢Ͱλ
    ABS_ENCODER_SPI_CSN (1);   
    
    return (angle>>4);              //12λȣλ                 
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      Լ캯
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void encoder_self5_check(void)
{
	uint8 val;
    do
    {
        encoder_spi_r_reg_byte(6,&val);
        //ԭ¼
        //1 ˣµĸʼ
        //2 ߴûнӺ
    }while(0x1C != val);
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼ
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void encoder_init_spi(void)
{
	spi_init(ABS_ENCODER_SPI_NUM, ABS_ENCODER_SPI_SCK_PIN, ABS_ENCODER_SPI_MOSI_PIN,ABS_ENCODER_SPI_MISO_PIN, 0, MASTER, SPI_SYSclk_DIV_4);

	encoder_self5_check();
	encoder_spi_w_reg_byte(DIR_REG,0x00);//ת תֵС0x00   תֵ0x80
	set_zero_position_spi(0);                   //ƫ
}


//-------------------------ΪӲSPI--------------------------//
//-------------------------ΪӲSPI--------------------------//
//-------------------------ΪӲSPI--------------------------//
