/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2018,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		MPU6050
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ3184284598)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2019-04-30
 * @note		
					߶壺
					------------------------------------ 
					IIC
					SCL                 鿴SEEKFREE_MPU6050.HļڵMPU6050_SCL_PIN궨
					SDA                 鿴SEEKFREE_MPU6050.HļڵMPU6050_SDA_PIN궨  
					------------------------------------ 
 ********************************************************************************************************************/



#include "SEEKFREE_MPU6050.h"
#include "zf_delay.h"


int16 mpu6050_gyro_x,mpu6050_gyro_y,mpu6050_gyro_z;
int16 mpu6050_acc_x,mpu6050_acc_y,mpu6050_acc_z;


#define GET_MPU6050_SDA   		 	MPU6050_SDA_PIN
#define MPU6050_SCL_LOW()          	MPU6050_SCL_PIN = 0		//IO͵ƽ
#define MPU6050_SCL_HIGH()         	MPU6050_SCL_PIN = 1		//IOߵƽ  
#define MPU6050_SDA_LOW()          	MPU6050_SDA_PIN = 0		//IO͵ƽ
#define MPU6050_SDA_HIGH()         	MPU6050_SDA_PIN = 1		//IOߵƽ

#define ack 1      //Ӧ
#define no_ack 0   //Ӧ	

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICʱ
//  @return     void						
//  @since      v1.0
//  Sample usage:				IICͨѶʧܿԳjֵ
//-------------------------------------------------------------------------------------------------------------------
static void mpu6050_simiic_delay(void)
{
    uint16 j=MPU6050_IIC_DELAY;   
	while(j--);
}

//ڲʹãû
static void mpu6050_simiic_start(void)
{
	MPU6050_SDA_HIGH();
	MPU6050_SCL_HIGH();
	mpu6050_simiic_delay();
	MPU6050_SDA_LOW();
	mpu6050_simiic_delay();
	MPU6050_SCL_LOW();
}

//ڲʹãû
static void mpu6050_simiic_stop(void)
{
	MPU6050_SDA_LOW();
	MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	MPU6050_SCL_HIGH();
	mpu6050_simiic_delay();
	MPU6050_SDA_HIGH();
	mpu6050_simiic_delay();
}

//Ӧ(ack:SDA=0no_ack:SDA=0)
//ڲʹãû
static void mpu6050_simiic_sendack(unsigned char ack_dat)
{
    MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	if(ack_dat) MPU6050_SDA_LOW();
    else    	MPU6050_SDA_HIGH();

    MPU6050_SCL_HIGH();
    mpu6050_simiic_delay();
    MPU6050_SCL_LOW();
    mpu6050_simiic_delay();
}


static int mpu6050_sccb_waitack(void)
{
    MPU6050_SCL_LOW();

	mpu6050_simiic_delay();
	
	MPU6050_SCL_HIGH();
    mpu6050_simiic_delay();
	
    if(GET_MPU6050_SDA)           //ӦΪߵƽ쳣ͨʧ
    {

        MPU6050_SCL_LOW();
        return 0;
    }

    MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
    return 1;
}

//ֽڷͳ
//c(Ҳǵַ)մӦ
//ǴӦλ
//ڲʹãû
static void mpu6050_send_ch(uint8 c)
{
	uint8 i = 8;
    while(i--)
    {
        if(c & 0x80)	MPU6050_SDA_HIGH();//SDA 
        else			MPU6050_SDA_LOW();
        c <<= 1;
        mpu6050_simiic_delay();
        MPU6050_SCL_HIGH();                //SCL ߣɼź
        mpu6050_simiic_delay();
        MPU6050_SCL_LOW();                //SCL ʱ
    }
	mpu6050_sccb_waitack();
}


//ֽڽճ
//ݣ˳Ӧ|Ӧ|ʹ
//ڲʹãû
static uint8 mpu6050_read_ch(uint8 ack_x)
{
    uint8 i;
    uint8 c;
    c=0;
    MPU6050_SCL_LOW();
    mpu6050_simiic_delay();
    MPU6050_SDA_HIGH();             

    for(i=0;i<8;i++)
    {
        mpu6050_simiic_delay();
        MPU6050_SCL_LOW();         //ʱΪͣ׼λ
        mpu6050_simiic_delay();
        MPU6050_SCL_HIGH();         //ʱΪߣʹЧ
        mpu6050_simiic_delay();
        c<<=1;
        if(GET_MPU6050_SDA) 
        {
            c+=1;   //λյݴc
        }
    }

	MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	mpu6050_simiic_sendack(ack_x);
	
    return c;
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICдݵ豸Ĵ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat				д
//  @return     void						
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static void mpu6050_simiic_write_reg(uint8 dev_add, uint8 reg, uint8 dat)
{
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);   //ַдλ
	mpu6050_send_ch( reg );   				 //ʹӻĴַ
	mpu6050_send_ch( dat );   				 //Ҫд
	mpu6050_simiic_stop();
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIIC豸Ĵȡ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
uint8 mpu6050_simiic_read_reg(uint8 dev_add, uint8 reg)
{
	uint8 dat;
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	mpu6050_send_ch( reg );   				//ʹӻĴַ

	
	mpu6050_simiic_start();
	mpu6050_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
	dat = mpu6050_read_ch(no_ack);   				//ȡ
	mpu6050_simiic_stop();
	
	return dat;
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICȡֽ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat_add			ݱĵַָ
//  @param      num				ȡֽ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_simiic_read_regs(uint8 dev_add, uint8 reg, uint8 *dat_add, uint8 num)
{
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	mpu6050_send_ch( reg );   				//ʹӻĴַ

	
	mpu6050_simiic_start();
	mpu6050_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
    while(--num)
    {
        *dat_add = mpu6050_read_ch(ack); //ȡ
        dat_add++;
    }
    *dat_add = mpu6050_read_ch(no_ack); //ȡ
	mpu6050_simiic_stop();
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      MPU6050Լ캯
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static uint8 mpu6050_self1_check(void)
{
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, PWR_MGMT_1, 0x00);	//״̬
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, SMPLRT_DIV, 0x07);   //125HZ
    if(0x07 != mpu6050_simiic_read_reg(MPU6050_DEV_ADDR, SMPLRT_DIV))
    {
		printf("mpu6050 init error.\r\n");
		return 1;
        //ԭ¼
        //1 MPU6050ˣµĸʼ
        //2 ߴûнӺ
        //3 Ҫ裬3.3V
		//4 ûеģIICĳʼ
    }

	return 0;

}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼMPU6050
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
uint8 mpu6050_init(void)
{
    delay_ms(100);                                   //ϵʱ

    if(mpu6050_self1_check())
	{
		return 1;
	}
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, PWR_MGMT_1, 0x00);	//״̬
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, SMPLRT_DIV, 0x07);   //125HZ
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, MPU6050_CONFIG, 0x04);       //
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, GYRO_CONFIG, 0x18);  //2000
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, ACCEL_CONFIG, 0x10); //8g
	mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, User_Control, 0x00);
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, INT_PIN_CFG, 0x02);
	return 0;
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡMPU6050ٶȼ
//  @param      NULL
//  @return     void
//  @since      v1.0
//  Sample usage:				ִиúֱӲ鿴Ӧı
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_get_accdata(void)
{
    uint8 dat[6];

    mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, ACCEL_XOUT_H, dat, 6);  
    mpu6050_acc_x = (int16)(((uint16)dat[0]<<8 | dat[1]));
    mpu6050_acc_y = (int16)(((uint16)dat[2]<<8 | dat[3]));
    mpu6050_acc_z = (int16)(((uint16)dat[4]<<8 | dat[5]));
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡMPU6050
//  @param      NULL
//  @return     void
//  @since      v1.0
//  Sample usage:				ִиúֱӲ鿴Ӧı
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_get_gyro(void)
{
    uint8 dat[6];

    mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, GYRO_XOUT_H, dat, 6);  
    mpu6050_gyro_x = (int16)(((uint16)dat[0]<<8 | dat[1]));
    mpu6050_gyro_y = (int16)(((uint16)dat[2]<<8 | dat[3]));
    mpu6050_gyro_z = (int16)(((uint16)dat[4]<<8 | dat[5]));
}









